%define __libtoolize    /bin/true

%define my_target_cpu %{_target_cpu}
%ifarch ppc
%define my_target_cpu powerpc
%endif
%ifarch amd64
%define my_target_cpu x86_64
%endif


%define lib_major_kdec	1
%define lib_kdec	%mklibname kdec %{lib_major_kdec}

%define lib_major_kjsembed	1
%define lib_kjsembed	%mklibname kjsembed %{lib_major_kjsembed}


%define lib_major_smoke	1
%define lib_smoke	%mklibname smoke %{lib_major_smoke}

%define lib_major_ruby	1
%define lib_ruby	%mklibname qtruby %{lib_major_ruby}


%define use_enable_final 0

%if %mdkversion >= 200600
%define unstable 0
%else
%define unstable 0
%endif

Name:		kdebindings
Summary: 	Kdebindings
Version: 	3.4.2
Release: 	2mdk

URL:		ftp://ftp.kde.org/pub/kde/stable/%version/src/
Source:     	ftp://ftp.kde.org/pub/kde/stable/%version/src/%name-%version.tar.bz2

Patch4:		kdelibs-3.2-remove-rpath.patch.bz2
Patch5:		kdebindings-3.4.0-fix-lib64.patch.bz2
Patch7:		kdebindings-3.4.1-fix-search-qconfigh-multiarch.patch.bz2
Patch8:		kdebindings-3.4.2-fix-compile.patch.bz2

License:  	GPL
Group: 		Graphical desktop/KDE
BuildRoot: 	%_tmppath/%name-%version-%release-root

BuildRequires:  gettext 
BuildRequires:	kdelibs-devel
BuildRequires:	bzip2-devel
BuildRequires:  gtk+-devel
BuildRequires:  python-devel
BuildRequires:	perl-devel
BuildRequires:	texinfo
BuildRequires:	ruby-devel
BuildRequires:	openssl-devel


BuildRequires:	qscintilla-devel

%description
This package contains
	* dcopc: DCOP bindings for C
	* dcopjava: DCOP bindings for JAVA
	* dcopperl: DCOP bindings for Perl
	* dcoppython: DCOP bindings for Python (broken)
	* kalyptus: C, Objective-C and Java bindings generator
	* kdec: KDE bindings for C
	* kdejava: KDE bindings for Java JNI to use Qt/KDE classes with Java
	* kdeobjc: KDE bindings for Objective-C (broken)
	* qtjava: Qt bindings for Java JNI to use Qt/KDE classes with Java
	* qtruby: Qt bindings for Ruby
	* qtobjc: Qt bindings for Objective-C (broken)


%package -n smoke
Summary:	Qt bindings for Python.
Group:		Development/KDE and Qt
Requires:	%{lib_smoke} = %version-%release

%description -n smoke
This package provides Qt bindings for Python.

%package -n %{lib_smoke}
Summary:	Qt bindings for Python.
Group:		Development/KDE and Qt

%description -n %{lib_smoke}
This package provides Qt bindings for Python.

%package -n %{lib_smoke}-devel
Summary:	Header files for libsmoke.
Group:		Development/KDE and Qt
Requires:	%{lib_smoke} = %version-%release
Provides:	libsmoke-devel = %version-%release

%description -n %{lib_smoke}-devel
Header files for libsmoke.

%package -n kjsembed
Summary:	KJS Javascript interpreter.
Group:		Development/KDE and Qt
Requires:	%lib_kjsembed = %version-%release

%description -n kjsembed
A library for embedding the KJS Javascript interpreter in application.

%package -n %lib_kjsembed
Summary:	KJS Javascript interpreter.
Group:		Development/KDE and Qt

%description -n %lib_kjsembed
A library for embedding the KJS Javascript interpreter in application.

%package -n %lib_kjsembed-devel
Summary:	Header files for KJS Javascript interpreter.
Group:		Development/KDE and Qt
Requires:	%lib_kjsembed = %version-%release
Provides:	kjsembed-devel


%description -n %lib_kjsembed-devel
Header files for embedding the KJS Javascript interpreter in application.


%package -n kdec
Summary:	KDE bindings for C.
Group:		Development/KDE and Qt
Requires:	%{lib_kdec} = %version-%release
Obsoletes:	libsmokeqt1, libsmokeqt1-devel


%description -n kdec
This package provides KDE bindings for C.

%package -n %{lib_kdec}
Summary:	KDE bindings for C.
Group:		Development/KDE and Qt
Obsoletes:  libsmokeqt1, libsmokeqt1-devel

%description -n %{lib_kdec}
This package provides KDE bindings for C.

%package -n %{lib_kdec}-devel
Summary:	Header files for libkdec.
Group:		Development/KDE and Qt
#Requires:	%{lib_kdec} = %version-%release
Provides:	libkdec-devel = %version-%release
Obsoletes:  libsmokeqt1, libsmokeqt1-devel

%description -n %{lib_kdec}-devel
Header files for libkdec.



%package -n qtruby
Summary:	KDE Binding for Ruby.
Group:		Development/KDE and Qt
Requires:	%lib_ruby = %version-%release

%description -n qtruby
A binding for Ruby language.

%package -n %lib_ruby
Summary:	KDE Binding for Ruby.
Group:		Development/KDE and Qt

%description -n %lib_ruby
Librairie for KDE binding for Ruby.

%package -n %lib_ruby-devel
Summary:	Header files for KDE binding for Ruby.
Group:		Development/KDE and Qt
Requires:	%lib_ruby = %version-%release
Provides:   qtruby-devel

%description -n %lib_ruby-devel
Header files for kde bindings for Ruby.


%prep
%setup -q 
%patch4 -p1 -b .fix_remove_rpath
%if "%{_lib}" != "lib"
%patch5 -p1 -b .fix_python_search_kde_x86_64
%endif

%patch7 -p1 -b .fix_multiarch
%patch8 -p1 -b .fix_compile

%build
make -f admin/Makefile.common cvs

export QTDIR=%_prefix/lib/qt3
export KDEDIR=%_prefix

export LD_LIBRARY_PATH=$QTDIR/%_lib:$LD_LIBRARY_PATH

# update config.{sub,guess} scripts
%{?__cputoolize: %{__cputoolize}}

%ifarch %ix86
CFLAGS="%optflags" CXXFLAGS="`echo %optflags |sed -e 's/-fomit-frame-pointer//'`" \
%else
CFLAGS="%optflags" CXXFLAGS="%optflags" \
%endif
    %configure --build=%_target_platform \
				--host=%_target_platform \
				--enable-new-ldflags \
%if %unstable
                    --enable-debug=full \
%else
                    --disable-debug \
%endif
%if %use_enable_final				
				--enable-final \
%else
				--disable-final \
%endif				
				--enable-shared \
				--disable-static \
				--disable-objprelink \
				--with-xinerama \
				--enable-mt \
				--disable-rpath \
%if "%{_lib}" != "lib"
                --enable-libsuffix="%(A=%{_lib}; echo ${A/lib/})" \
%endif
				--without-java

# Don't compile smoke (need...more...memory...)
#perl -pi -e 's/smoke / /g' Makefile
# Don't compile dcopc untill someone requests it
# Is it needed by qtc or kdec?
#perl -pi -e 's/dcopc / /g' Makefile
# Don't compile kjsembed untill someone requests it
#perl -pi -e 's/kjsembed / /g' Makefile
# Don't compile kmozilla or xpart_notepad untill someone requests it
perl -pi -e 's/xparts / /g' Makefile

perl -pi -e 's/qtsharp / /g' Makefile
# kdec compile is broken since gcc-3.3.1-0.6mdk
#perl -pi -e 's/kdec/ /g' Makefile


make


%install
if [ -d $RPM_BUILD_ROOT ]; then rm -r $RPM_BUILD_ROOT; fi

make DESTDIR=%buildroot install

install -d %buildroot/%_menudir/
kdedesktop2mdkmenu.pl kdebindings-kjsembed Applications/Development %buildroot/%_datadir/applications/kde/kjscmd.desktop %buildroot/%_menudir/kdebindings-kjscmd



%clean
if [ -d $RPM_BUILD_ROOT ]; then rm -r $RPM_BUILD_ROOT; fi


%post -n %{lib_smoke} -p /sbin/ldconfig
%postun -n %{lib_smoke} -p /sbin/ldconfig


%post -n kjsembed
/sbin/ldconfig
%update_menus


%postun -n kjsembed
/sbin/ldconfig
%clean_menus


%postun -n %lib_kjsembed -p /sbin/ldconfig
%post -n %lib_kjsembed -p /sbin/ldconfig

%post -n %{lib_kdec} -p /sbin/ldconfig
%postun -n %{lib_kdec} -p /sbin/ldconfig


%postun -n %lib_ruby-devel -p /sbin/ldconfig
%post -n %lib_ruby-devel -p /sbin/ldconfig

%post -n %{lib_ruby} -p /sbin/ldconfig
%postun -n %{lib_ruby} -p /sbin/ldconfig


%files -n smoke
%defattr(-,root,root)
%_bindir/pylupdate
%_bindir/pyuic
%_bindir/sip

%dir %_datadir/sip/dcop/
%_datadir/sip/dcop/*.sip

%dir %_datadir/sip/kutils/
%_datadir/sip/kutils/*.sip

%dir %_datadir/sip/qtext/
%_datadir/sip/qtext/*.sip

%dir %_datadir/sip/kdecore/
%_datadir/sip/kdecore/*.sip

%dir %_datadir/sip/kdefx/
%_datadir/sip/kdefx/*.sip

%dir %_datadir/sip/kdeprint/
%_datadir/sip/kdeprint/*.sip

%dir %_datadir/sip/kdesu/
%_datadir/sip/kdesu/*.sip

%dir %_datadir/sip/kdeui/
%_datadir/sip/kdeui/*.sip

%dir %_datadir/sip/kfile/
%_datadir/sip/kfile/*.sip



%dir %_datadir/sip/khtml/
%_datadir/sip/khtml/*.sip

%dir %_datadir/sip/kio/
%_datadir/sip/kio/*.sip

%dir %_datadir/sip/kmdi/
%_datadir/sip/kmdi/*.sip

%dir %_datadir/sip/kparts/
%_datadir/sip/kparts/*.sip

%dir %_datadir/sip/kspell/
%_datadir/sip/kspell/*.sip

%dir %_datadir/sip/qt/
%_datadir/sip/qt/*.sip

%dir %_datadir/sip/qtcanvas/
%_datadir/sip/qtcanvas/*.sip

%dir %_datadir/sip/qtgl/
%_datadir/sip/qtgl/*.sip

%dir %_datadir/sip/qtnetwork/
%_datadir/sip/qtnetwork/*.sip

%dir %_datadir/sip/qtsql/
%_datadir/sip/qtsql/*.sip

%dir %_datadir/sip/qttable/
%_datadir/sip/qttable/*.sip

%dir %_datadir/sip/qtui/
%_datadir/sip/qtui/*.sip

%dir %_datadir/sip/qtxml/
%_datadir/sip/qtxml/*.sip

%files -n %{lib_smoke}
%defattr(-,root,root)
%_libdir/libsmokekde.so.*
%_libdir/libsmokekde.la
%_libdir/kde3/libqprocessplugin.la
%_libdir/kde3/libqprocessplugin.so

%files -n %{lib_smoke}-devel
%defattr(-,root,root)
%_libdir/libsmokekde.so
%_includedir/python2.4/sip.h


%files -n kdec
%defattr(-,root,root)
#%doc kdec/AUTHORS
#%_bindir/clib
%_prefix/local/share/man/man3/DCOP.3pm


%files -n %{lib_kdec}
%defattr(-,root,root)
#%_libdir/libkdec.so.*
%_libdir/libsmokeqt.so.*
%_libdir/libsmokeqt.la

%perl_sitearch/*.pm
%perl_sitearch/DCOP/Object.pm
%perl_sitearch/auto/DCOP/*.so
%_libdir/python2.4/pydcop.py
%_libdir/python2.4/site-packages/*.la
%_libdir/python2.4/site-packages/*.so
%_libdir/python2.4/site-packages/*.py


%files -n %{lib_kdec}-devel
%defattr(-,root,root)
#%_libdir/libkdec.so
##%_libdir/libkdec.*a
%_includedir/smoke.h
%_libdir/libsmokeqt.so

%files -n kjsembed
%defattr(-,root,root)
%_bindir/kjscmd
%_bindir/jsaccess
%_bindir/embedjs

%_datadir/applnk/Utilities/embedjs.desktop
%_datadir/apps/embedjs/embedjsui.rc

%dir %_datadir/apps/kate/scripts/
%_datadir/apps/kate/scripts/swaptabs.desktop
%_datadir/apps/kate/scripts/swaptabs.js
%_datadir/apps/kate/scripts/swaptabs.ui

%_datadir/apps/kjsembed/cmdline.js
%_datadir/man/man1/kjscmd.1.bz2
%_datadir/services/qprocess_plugin.desktop

%_menudir/kdebindings-kjscmd
%_datadir/applications/kde/kjscmd.desktop

%_datadir/services/customobject_plugin.desktop
%_datadir/services/customqobject_plugin.desktop
%_datadir/servicetypes/binding_type.desktop
%_datadir/services/imagefx_plugin.desktop

%_datadir/services/javascript.desktop

%_datadir/icons/hicolor/16x16/apps/embedjs.png
%_datadir/icons/hicolor/32x32/apps/embedjs.png

%_datadir/services/kfileitem_plugin.desktop

%files -n %lib_kjsembed
%defattr(-,root,root)
%_libdir/libkjsembed.la
%_libdir/libkjsembed.so.*

%_libdir/kde3/libjsconsoleplugin.la
%_libdir/kde3/libjsconsoleplugin.so
%_libdir/kde3/libcustomobjectplugin.la
%_libdir/kde3/libcustomobjectplugin.so
%_libdir/kde3/libcustomqobjectplugin.la
%_libdir/kde3/libcustomqobjectplugin.so
%_libdir/kde3/libimagefxplugin.la
%_libdir/kde3/libimagefxplugin.so

############TODO: verify it
%_libdir/kde3/libfileitemplugin.la
%_libdir/kde3/libfileitemplugin.so
%_libdir/kde3/libjavascript.la
%_libdir/kde3/libjavascript.so


%files -n %lib_kjsembed-devel
%defattr(-,root,root)
%dir %_includedir/kjsembed/
%_includedir/kjsembed/*.h
%_libdir/libkjsembed.so



%files -n qtruby
%defattr(-,root,root)
%_bindir/krubyinit
%_bindir/qtrubyinit
%_bindir/rbkdeapi
%_bindir/rbkdesh
%_bindir/rbqtapi
%_bindir/rbqtsh
%_bindir/rbuic
%_bindir/rbkconfig_compiler

%files -n %lib_ruby
%defattr(-,root,root)
%{_prefix}/lib/ruby/site_ruby/1.8/KDE/korundum.rb
%{_prefix}/lib/ruby/site_ruby/1.8/Korundum.rb
%{_prefix}/lib/ruby/site_ruby/1.8/Qt.rb
%{_prefix}/lib/ruby/site_ruby/1.8/Qt/qtruby.rb

%{_prefix}/lib/ruby/site_ruby/1.8/%{my_target_cpu}-%{_host_os}/korundum.la
%{_prefix}/lib/ruby/site_ruby/1.8/%{my_target_cpu}-%{_host_os}/korundum.so.*
%{_prefix}/lib/ruby/site_ruby/1.8/%{my_target_cpu}-%{_host_os}/qtruby.la
%{_prefix}/lib/ruby/site_ruby/1.8/%{my_target_cpu}-%{_host_os}/qtruby.so.*
%{_prefix}/lib/ruby/site_ruby/1.8/%{my_target_cpu}-%{_host_os}/qui.la
%{_prefix}/lib/ruby/site_ruby/1.8/%{my_target_cpu}-%{_host_os}/qui.so.*


%files -n %lib_ruby-devel
%defattr(-,root,root)
%{_prefix}/lib/ruby/site_ruby/1.8/%{my_target_cpu}-%{_host_os}/korundum.so
%{_prefix}/lib/ruby/site_ruby/1.8/%{my_target_cpu}-%{_host_os}/qtruby.so
%{_prefix}/lib/ruby/site_ruby/1.8/%{my_target_cpu}-%{_host_os}/qui.so





%changelog
* Wed Aug 10 2005 Laurent Montel <lmontel@mandriva.com
+ 2005-08-10 03:02:03 (569)
- Fix compile

* Tue Aug 09 2005 Laurent Montel <lmontel@mandriva.com
+ 2005-08-09 06:58:50 (560)
- remove qtc and qtsharp from spec
- buildrequires openssl-devel
  Patch from mpol@mandriva.org

* Thu Aug 04 2005 Laurent Montel <lmontel@mandriva.com
+ 2005-08-04 02:14:21 (525)
- Add build requires openssl-devel to fix MDV  #17275

* Tue May 24 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-05-24 16:42:57 (45)
- Uploading package ./kdebindings

%changelog
* Wed Apr 20 2005 Laurent MONTEL <lmontel@mandriva.com> 3.4.0-4mdk
- Fix provides

* Mon Apr 18 2005 Laurent MONTEL <lmontel@mandriva.com> 3.4.0-3mdk
- Fix BuildRequires/Compile on x86_64 (thanks Nicolas Chipaux)

* Sat Apr 16 2005 Laurent MONTEL <lmontel@mandriva.com> 3.4.0-2mdk
- Rebuild 

* Thu Apr 14 2005 Laurent MONTEL <lmontel@mandriva.com> 3.4.0-1mdk
- 3.4.0
- --enable-new-ldflags

* Fri Mar 18 2005 Laurent MONTEL <lmontel@mandrakesoft.com> 3.3.2-1mdk
- 3.3.2

* Mon Feb 07 2005 Laurent MONTEL <lmontel@mandrakesoft.com> 3.3.2-1mdk
- 3.3.2

* Thu Dec 02 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.3.1-3mdk
- 3.3.2

* Thu Oct 21 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.3.1-2mdk
- Sync with CVS

* Fri Oct 08 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.3.1-1mdk
- 3.3.1

* Fri Sep 10 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2.3-9mdk
- Remove last mono buildRequires

* Tue Sep 07 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2.3-8mdk
- Remove unused BuildRequires

* Thu Aug 19 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2.3-7mdk
- Remove unused patch

* Thu Aug 12 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2.3-6mdk
- Disable compile for mono

* Tue Aug 10 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2.3-5mdk
- Fix add/remove debug

* Tue Jul 27 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2.3-4mdk
- Fix spec file

* Wed Jul 21 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2.3-3mdk
- Fix remove rpath

* Tue Jul 06 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2.3-2mdk
- Obsoletes smokeqt

* Mon Jun 14 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2.3-1mdk
- 3.2.3

* Mon Apr 19 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2.1-2mdk
- 3.2.2

* Tue Apr 06 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2.1-2mdk
- Fix spec file to using rpmbuildupdate

* Fri Apr 02 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2.1-1mdk
- 3.2.1

* Tue Mar 30 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2-2mdk
- Use %%configure
- Use mdkversion

* Tue Feb 24 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2-1mdk
- 3.2 

* Fri Jan 30 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.2-0.1mdk
- Fix for package freeze

* Wed Jan 21 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.1.95-1mdk
- 3.1.95

* Thu Jan 15 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.1.94-7mdk
- Sync with CVS

* Mon Jan 12 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.1.94-6mdk
- Fix BuildRequires
- Sync with CVS
- Reverte VFolder menu type to 'menu' menu type

* Fri Jan 09 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.1.94-5mdk
- Fix description
- Fix requires
- Add use_enable_final variable

* Mon Jan 05 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 3.1.94-4mdk
- Sync with CVS


* Mon Dec 29 2003 Laurent MONTEL <lmontel@mandrakesoft.com> 3.1.94-3mdk
- Sync with CVS

* Thu Dec 18 2003 Laurent MONTEL <lmontel@mandrakesoft.com> 3.1.94-2mdk
- Sync with CVS

* Mon Dec 08 2003 Laurent MONTEL <lmontel@mandrakesoft.com> 3.1.94-1mdk
- 3.1.94

* Thu Jul 31 2003 Marcel Pol <mpol@gmx.net> 3.1.3-1mdk
- resurrect from the dead into contrib
- removed distro specific options
- buildrequires
- only compile qtc and qtsharp
- don't compile kdec for now, compile breaks since gcc-3-3-1-0.6mdk
- libpolicy/mklibname

* Mon Aug 05 2002 Laurent MONTEL <lmontel@mandrakesoft.com> 3.0.2-1mdk
- kde3.0.2
- Add patch1/patch2 fix qtc compile with qt
- Add patch3 fix gcc-3.2 compile.

* Fri Mar 22 2002 David BAUDENS <baudens@mandrakesoft.com> 2.2.2-6mdk
- Enable 8.3 support
- Disable -fomit-frame-pointer on all supported %%ix86 architectures
- Fix BuildRequires for PPC (8.2 and 8.3)

* Fri Feb 15 2002 Laurent MONTEL <lmontel@mandrakesoft.com> 2.2.2-5mdk
- Rebuild

* Tue Jan 15 2002 David BAUDENS <baudens@mandrakesoft.com> 2.2.2-4mdk
- Fix ./configure on all supported distributions
- 8.2: don't build static libraries
- Fix Group: on all supported distributions

* Fri Dec 07 2001 Laurent Montel <lmontel@mandrakesoft.com> 2.2.2-3mdk
- made rpmlint happy

* Mon Dec 03 2001 Laurent Montel <lmontel@mandrakesoft.com> 2.2.2-2mdk
- Remove objprelink

* Thu Nov 15 2001 Laurent Montel <lmontel@mandrakesoft.com> 2.2.2-1mdk
- kde 2.2.2

* Tue Sep 23 2001 David BAUDENS <baudens@mandrakesoft.com> 2.2.1-3mdk
- Official updates for Linux-Mandrake 7.2 and 8.0
- Add support for Mandrake Linux 8.2
- Add Packager: Mandrake Linux KDE Team <kde@mandrakesoft.com>
- Rewrite %%configure steps
- 8.2: enable objprelink

* Sat Sep 21 2001 Laurent Montel <lmontel@mandrakesoft.com> 2.2.1-2mdk
- Remove update-menu/clean-menu (there is not menu file in this package)

* Wed Sep 19 2001 Laurent Montel <lmontel@mandrakesoft.com> 2.2.1-1mdk
- kde 2.2.1

* Fri Aug 31 2001 Laurent Montel <lmontel@mandrakesoft.com> 2.2-3mdk
- Fix build requires

* Fri Aug 24 2001 Laurent Montel <lmontel@mandrakesoft.com> 2.2-2mdk
- Rebuild with new kdelibs

* Wed Aug 08 2001 Laurent Montel <lmontel@mandrakesoft.com> 2.2-1mdk
- kde 2.2

* Thu Jun 28 2001 David BAUDENS <baudens@mandrakesoft.com> 2.2-0.beta1.1mdk
- KDE 2.2.beta1
- Rewrite %%files sections

* Tue May 23 2001 Laurent Montel <lmontel@mandrakesoft.com> 2.2-0.alpha2.1mdk
- kde2.2alpha2
